/*Minified by MAIYUN.NET using terser*/import*as nls from"../../../nls.js";import*as platform from"../../../base/common/platform.js";import{USUAL_WORD_SEPARATORS}from"../core/wordHelper.js";import*as arrays from"../../../base/common/arrays.js";import*as objects from"../../../base/common/objects.js";import{EDITOR_MODEL_DEFAULTS}from"../core/textModelDefaults.js";export const MINIMAP_GUTTER_WIDTH=8;export class ConfigurationChangedEvent{constructor(e){this._values=e}hasChanged(e){return this._values[e]}}export class ComputeOptionsMemory{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}class BaseEditorOption{constructor(e,t,o,i){this.id=e,this.name=t,this.defaultValue=o,this.schema=i}applyUpdate(e,t){return applyUpdate(e,t)}compute(e,t,o){return o}}export class ApplyUpdateResult{constructor(e,t){this.newValue=e,this.didChange=t}}function applyUpdate(e,t){if("object"!=typeof e||"object"!=typeof t||!e||!t)return new ApplyUpdateResult(t,e!==t);if(Array.isArray(e)||Array.isArray(t)){const o=Array.isArray(e)&&Array.isArray(t)&&arrays.equals(e,t);return new ApplyUpdateResult(t,!o)}let o=!1;for(const i in t)if(t.hasOwnProperty(i)){const n=applyUpdate(e[i],t[i]);n.didChange&&(e[i]=n.newValue,o=!0)}return new ApplyUpdateResult(e,o)}class ComputedEditorOption{constructor(e){this.schema=void 0,this.id=e,this.name="_never_",this.defaultValue=void 0}applyUpdate(e,t){return applyUpdate(e,t)}validate(e){return this.defaultValue}}class SimpleEditorOption{constructor(e,t,o,i){this.id=e,this.name=t,this.defaultValue=o,this.schema=i}applyUpdate(e,t){return applyUpdate(e,t)}validate(e){return void 0===e?this.defaultValue:e}compute(e,t,o){return o}}export function boolean(e,t){return void 0===e?t:"false"!==e&&Boolean(e)}class EditorBooleanOption extends SimpleEditorOption{constructor(e,t,o,i=undefined){void 0!==i&&(i.type="boolean",i.default=o),super(e,t,o,i)}validate(e){return boolean(e,this.defaultValue)}}export function clampedInt(e,t,o,i){if(void 0===e)return t;let n=parseInt(e,10);return isNaN(n)?t:(n=Math.max(o,n),n=Math.min(i,n),0|n)}class EditorIntOption extends SimpleEditorOption{constructor(e,t,o,i,n,r=undefined){void 0!==r&&(r.type="integer",r.default=o,r.minimum=i,r.maximum=n),super(e,t,o,r),this.minimum=i,this.maximum=n}static clampedInt(e,t,o,i){return clampedInt(e,t,o,i)}validate(e){return EditorIntOption.clampedInt(e,this.defaultValue,this.minimum,this.maximum)}}class EditorFloatOption extends SimpleEditorOption{constructor(e,t,o,i,n){void 0!==n&&(n.type="number",n.default=o),super(e,t,o,n),this.validationFn=i}static clamp(e,t,o){return e<t?t:e>o?o:e}static float(e,t){if("number"==typeof e)return e;if(void 0===e)return t;const o=parseFloat(e);return isNaN(o)?t:o}validate(e){return this.validationFn(EditorFloatOption.float(e,this.defaultValue))}}class EditorStringOption extends SimpleEditorOption{static string(e,t){return"string"!=typeof e?t:e}constructor(e,t,o,i=undefined){void 0!==i&&(i.type="string",i.default=o),super(e,t,o,i)}validate(e){return EditorStringOption.string(e,this.defaultValue)}}export function stringSet(e,t,o){return"string"!=typeof e||-1===o.indexOf(e)?t:e}class EditorStringEnumOption extends SimpleEditorOption{constructor(e,t,o,i,n=undefined){void 0!==n&&(n.type="string",n.enum=i,n.default=o),super(e,t,o,n),this._allowedValues=i}validate(e){return stringSet(e,this.defaultValue,this._allowedValues)}}class EditorEnumOption extends BaseEditorOption{constructor(e,t,o,i,n,r,s=undefined){void 0!==s&&(s.type="string",s.enum=n,s.default=i),super(e,t,o,s),this._allowedValues=n,this._convert=r}validate(e){return"string"!=typeof e||-1===this._allowedValues.indexOf(e)?this.defaultValue:this._convert(e)}}function _autoIndentFromString(e){switch(e){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class EditorAccessibilitySupport extends BaseEditorOption{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[nls.localize("accessibilitySupport.auto","The editor will use platform APIs to detect when a Screen Reader is attached."),nls.localize("accessibilitySupport.on","The editor will be permanently optimized for usage with a Screen Reader. Word wrapping will be disabled."),nls.localize("accessibilitySupport.off","The editor will never be optimized for usage with a Screen Reader.")],default:"auto",description:nls.localize("accessibilitySupport","Controls whether the editor should run in a mode where it is optimized for screen readers. Setting to on will disable word wrapping.")})}validate(e){switch(e){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(e,t,o){return 0===o?e.accessibilitySupport:o}}class EditorComments extends BaseEditorOption{constructor(){const e={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",e,{"editor.comments.insertSpace":{type:"boolean",default:e.insertSpace,description:nls.localize("comments.insertSpace","Controls whether a space character is inserted when commenting.")},"editor.comments.ignoreEmptyLines":{type:"boolean",default:e.ignoreEmptyLines,description:nls.localize("comments.ignoreEmptyLines","Controls if empty lines should be ignored with toggle, add or remove actions for line comments.")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{insertSpace:boolean(t.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:boolean(t.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}function _cursorBlinkingStyleFromString(e){switch(e){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}export var TextEditorCursorStyle;function _cursorStyleFromString(e){switch(e){case"line":return TextEditorCursorStyle.Line;case"block":return TextEditorCursorStyle.Block;case"underline":return TextEditorCursorStyle.Underline;case"line-thin":return TextEditorCursorStyle.LineThin;case"block-outline":return TextEditorCursorStyle.BlockOutline;case"underline-thin":return TextEditorCursorStyle.UnderlineThin}}!function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"}(TextEditorCursorStyle||(TextEditorCursorStyle={}));class EditorClassName extends ComputedEditorOption{constructor(){super(130)}compute(e,t,o){const i=["monaco-editor"];return t.get(35)&&i.push(t.get(35)),e.extraEditorClassName&&i.push(e.extraEditorClassName),"default"===t.get(68)?i.push("mouse-default"):"copy"===t.get(68)&&i.push("mouse-copy"),t.get(102)&&i.push("showUnused"),t.get(128)&&i.push("showDeprecated"),i.join(" ")}}class EditorEmptySelectionClipboard extends EditorBooleanOption{constructor(){super(33,"emptySelectionClipboard",!0,{description:nls.localize("emptySelectionClipboard","Controls whether copying without a selection copies the current line.")})}compute(e,t,o){return o&&e.emptySelectionClipboard}}class EditorFind extends BaseEditorOption{constructor(){const e={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(37,"find",e,{"editor.find.cursorMoveOnType":{type:"boolean",default:e.cursorMoveOnType,description:nls.localize("find.cursorMoveOnType","Controls whether the cursor should jump to find matches while typing.")},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:e.seedSearchStringFromSelection,enumDescriptions:[nls.localize("editor.find.seedSearchStringFromSelection.never","Never seed search string from the editor selection."),nls.localize("editor.find.seedSearchStringFromSelection.always","Always seed search string from the editor selection, including word at cursor position."),nls.localize("editor.find.seedSearchStringFromSelection.selection","Only seed search string from the editor selection.")],description:nls.localize("find.seedSearchStringFromSelection","Controls whether the search string in the Find Widget is seeded from the editor selection.")},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:e.autoFindInSelection,enumDescriptions:[nls.localize("editor.find.autoFindInSelection.never","Never turn on Find in Selection automatically (default)."),nls.localize("editor.find.autoFindInSelection.always","Always turn on Find in Selection automatically."),nls.localize("editor.find.autoFindInSelection.multiline","Turn on Find in Selection automatically when multiple lines of content are selected.")],description:nls.localize("find.autoFindInSelection","Controls the condition for turning on Find in Selection automatically.")},"editor.find.globalFindClipboard":{type:"boolean",default:e.globalFindClipboard,description:nls.localize("find.globalFindClipboard","Controls whether the Find Widget should read or modify the shared find clipboard on macOS."),included:platform.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:e.addExtraSpaceOnTop,description:nls.localize("find.addExtraSpaceOnTop","Controls whether the Find Widget should add extra lines on top of the editor. When true, you can scroll beyond the first line when the Find Widget is visible.")},"editor.find.loop":{type:"boolean",default:e.loop,description:nls.localize("find.loop","Controls whether the search automatically restarts from the beginning (or the end) when no further matches can be found.")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{cursorMoveOnType:boolean(t.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:"boolean"==typeof e.seedSearchStringFromSelection?e.seedSearchStringFromSelection?"always":"never":stringSet(t.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:"boolean"==typeof e.autoFindInSelection?e.autoFindInSelection?"always":"never":stringSet(t.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:boolean(t.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:boolean(t.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:boolean(t.loop,this.defaultValue.loop)}}}export class EditorFontLigatures extends BaseEditorOption{constructor(){super(47,"fontLigatures",EditorFontLigatures.OFF,{anyOf:[{type:"boolean",description:nls.localize("fontLigatures","Enables/Disables font ligatures ('calt' and 'liga' font features). Change this to a string for fine-grained control of the 'font-feature-settings' CSS property.")},{type:"string",description:nls.localize("fontFeatureSettings","Explicit 'font-feature-settings' CSS property. A boolean can be passed instead if one only needs to turn on/off ligatures.")}],description:nls.localize("fontLigaturesGeneral","Configures font ligatures or font features. Can be either a boolean to enable/disable ligatures or a string for the value of the CSS 'font-feature-settings' property."),default:!1})}validate(e){return void 0===e?this.defaultValue:"string"==typeof e?"false"===e?EditorFontLigatures.OFF:"true"===e?EditorFontLigatures.ON:e:Boolean(e)?EditorFontLigatures.ON:EditorFontLigatures.OFF}}EditorFontLigatures.OFF='"liga" off, "calt" off',EditorFontLigatures.ON='"liga" on, "calt" on';class EditorFontInfo extends ComputedEditorOption{constructor(){super(46)}compute(e,t,o){return e.fontInfo}}class EditorFontSize extends SimpleEditorOption{constructor(){super(48,"fontSize",EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:EDITOR_FONT_DEFAULTS.fontSize,description:nls.localize("fontSize","Controls the font size in pixels.")})}validate(e){const t=EditorFloatOption.float(e,this.defaultValue);return 0===t?EDITOR_FONT_DEFAULTS.fontSize:EditorFloatOption.clamp(t,6,100)}compute(e,t,o){return e.fontInfo.fontSize}}class EditorFontWeight extends BaseEditorOption{constructor(){super(49,"fontWeight",EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:EditorFontWeight.MINIMUM_VALUE,maximum:EditorFontWeight.MAXIMUM_VALUE,errorMessage:nls.localize("fontWeightErrorMessage",'Only "normal" and "bold" keywords or numbers between 1 and 1000 are allowed.')},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:EditorFontWeight.SUGGESTION_VALUES}],default:EDITOR_FONT_DEFAULTS.fontWeight,description:nls.localize("fontWeight",'Controls the font weight. Accepts "normal" and "bold" keywords or numbers between 1 and 1000.')})}validate(e){return"normal"===e||"bold"===e?e:String(EditorIntOption.clampedInt(e,EDITOR_FONT_DEFAULTS.fontWeight,EditorFontWeight.MINIMUM_VALUE,EditorFontWeight.MAXIMUM_VALUE))}}EditorFontWeight.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],EditorFontWeight.MINIMUM_VALUE=1,EditorFontWeight.MAXIMUM_VALUE=1e3;class EditorGoToLocation extends BaseEditorOption{constructor(){const e={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},t={type:"string",enum:["peek","gotoAndPeek","goto"],default:e.multiple,enumDescriptions:[nls.localize("editor.gotoLocation.multiple.peek","Show peek view of the results (default)"),nls.localize("editor.gotoLocation.multiple.gotoAndPeek","Go to the primary result and show a peek view"),nls.localize("editor.gotoLocation.multiple.goto","Go to the primary result and enable peek-less navigation to others")]},o=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",e,{"editor.gotoLocation.multiple":{deprecationMessage:nls.localize("editor.gotoLocation.multiple.deprecated","This setting is deprecated, please use separate settings like 'editor.editor.gotoLocation.multipleDefinitions' or 'editor.editor.gotoLocation.multipleImplementations' instead.")},"editor.gotoLocation.multipleDefinitions":Object.assign({description:nls.localize("editor.editor.gotoLocation.multipleDefinitions","Controls the behavior the 'Go to Definition'-command when multiple target locations exist.")},t),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:nls.localize("editor.editor.gotoLocation.multipleTypeDefinitions","Controls the behavior the 'Go to Type Definition'-command when multiple target locations exist.")},t),"editor.gotoLocation.multipleDeclarations":Object.assign({description:nls.localize("editor.editor.gotoLocation.multipleDeclarations","Controls the behavior the 'Go to Declaration'-command when multiple target locations exist.")},t),"editor.gotoLocation.multipleImplementations":Object.assign({description:nls.localize("editor.editor.gotoLocation.multipleImplemenattions","Controls the behavior the 'Go to Implementations'-command when multiple target locations exist.")},t),"editor.gotoLocation.multipleReferences":Object.assign({description:nls.localize("editor.editor.gotoLocation.multipleReferences","Controls the behavior the 'Go to References'-command when multiple target locations exist.")},t),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:e.alternativeDefinitionCommand,enum:o,description:nls.localize("alternativeDefinitionCommand","Alternative command id that is being executed when the result of 'Go to Definition' is the current location.")},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:e.alternativeTypeDefinitionCommand,enum:o,description:nls.localize("alternativeTypeDefinitionCommand","Alternative command id that is being executed when the result of 'Go to Type Definition' is the current location.")},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:e.alternativeDeclarationCommand,enum:o,description:nls.localize("alternativeDeclarationCommand","Alternative command id that is being executed when the result of 'Go to Declaration' is the current location.")},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:e.alternativeImplementationCommand,enum:o,description:nls.localize("alternativeImplementationCommand","Alternative command id that is being executed when the result of 'Go to Implementation' is the current location.")},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:e.alternativeReferenceCommand,enum:o,description:nls.localize("alternativeReferenceCommand","Alternative command id that is being executed when the result of 'Go to Reference' is the current location.")}})}validate(e){var t,o,i,n,r;if(!e||"object"!=typeof e)return this.defaultValue;const s=e;return{multiple:stringSet(s.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:null!==(t=s.multipleDefinitions)&&void 0!==t?t:stringSet(s.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:null!==(o=s.multipleTypeDefinitions)&&void 0!==o?o:stringSet(s.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:null!==(i=s.multipleDeclarations)&&void 0!==i?i:stringSet(s.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:null!==(n=s.multipleImplementations)&&void 0!==n?n:stringSet(s.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:null!==(r=s.multipleReferences)&&void 0!==r?r:stringSet(s.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:EditorStringOption.string(s.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:EditorStringOption.string(s.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:EditorStringOption.string(s.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:EditorStringOption.string(s.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:EditorStringOption.string(s.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class EditorHover extends BaseEditorOption{constructor(){const e={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",e,{"editor.hover.enabled":{type:"boolean",default:e.enabled,description:nls.localize("hover.enabled","Controls whether the hover is shown.")},"editor.hover.delay":{type:"number",default:e.delay,minimum:0,maximum:1e4,description:nls.localize("hover.delay","Controls the delay in milliseconds after which the hover is shown.")},"editor.hover.sticky":{type:"boolean",default:e.sticky,description:nls.localize("hover.sticky","Controls whether the hover should remain visible when mouse is moved over it.")},"editor.hover.above":{type:"boolean",default:e.above,description:nls.localize("hover.above","Prefer showing hovers above the line, if there's space.")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{enabled:boolean(t.enabled,this.defaultValue.enabled),delay:EditorIntOption.clampedInt(t.delay,this.defaultValue.delay,0,1e4),sticky:boolean(t.sticky,this.defaultValue.sticky),above:boolean(t.above,this.defaultValue.above)}}}export class EditorLayoutInfoComputer extends ComputedEditorOption{constructor(){super(133)}compute(e,t,o){return EditorLayoutInfoComputer.computeLayout(t,{memory:e.memory,outerWidth:e.outerWidth,outerHeight:e.outerHeight,isDominatedByLongLines:e.isDominatedByLongLines,lineHeight:e.fontInfo.lineHeight,viewLineCount:e.viewLineCount,lineNumbersDigitCount:e.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:e.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:e.fontInfo.maxDigitWidth,pixelRatio:e.pixelRatio})}static computeContainedMinimapLineCount(e){const t=e.height/e.lineHeight,o=e.scrollBeyondLastLine?t-1:0,i=(e.viewLineCount+o)/(e.pixelRatio*e.height);return{typicalViewportLineCount:t,extraLinesBeyondLastLine:o,desiredRatio:i,minimapLineCount:Math.floor(e.viewLineCount/i)}}static _computeMinimapLayout(e,t){const o=e.outerWidth,i=e.outerHeight,n=e.pixelRatio;if(!e.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(n*i),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:i};const r=t.stableMinimapLayoutInput,s=r&&e.outerHeight===r.outerHeight&&e.lineHeight===r.lineHeight&&e.typicalHalfwidthCharacterWidth===r.typicalHalfwidthCharacterWidth&&e.pixelRatio===r.pixelRatio&&e.scrollBeyondLastLine===r.scrollBeyondLastLine&&e.minimap.enabled===r.minimap.enabled&&e.minimap.side===r.minimap.side&&e.minimap.size===r.minimap.size&&e.minimap.showSlider===r.minimap.showSlider&&e.minimap.renderCharacters===r.minimap.renderCharacters&&e.minimap.maxColumn===r.minimap.maxColumn&&e.minimap.scale===r.minimap.scale&&e.verticalScrollbarWidth===r.verticalScrollbarWidth&&e.isViewportWrapping===r.isViewportWrapping,l=e.lineHeight,a=e.typicalHalfwidthCharacterWidth,d=e.scrollBeyondLastLine,c=e.minimap.renderCharacters;let u=n>=2?Math.round(2*e.minimap.scale):e.minimap.scale;const h=e.minimap.maxColumn,p=e.minimap.size,g=e.minimap.side,m=e.verticalScrollbarWidth,f=e.viewLineCount,w=e.remainingWidth,b=e.isViewportWrapping,y=c?2:3;let S=Math.floor(n*i);const C=S/n;let z=!1,v=!1,E=y*u,O=u/n,k=1;if("fill"===p||"fit"===p){const{typicalViewportLineCount:o,extraLinesBeyondLastLine:r,desiredRatio:a,minimapLineCount:c}=EditorLayoutInfoComputer.computeContainedMinimapLineCount({viewLineCount:f,scrollBeyondLastLine:d,height:i,lineHeight:l,pixelRatio:n});if(f/c>1)z=!0,v=!0,u=1,E=1,O=u/n;else{let i=!1,d=u+1;if("fit"===p){const e=Math.ceil((f+r)*E);b&&s&&w<=t.stableFitRemainingWidth?(i=!0,d=t.stableFitMaxMinimapScale):i=e>S}if("fill"===p||i){z=!0;const i=u;E=Math.min(l*n,Math.max(1,Math.floor(1/a))),b&&s&&w<=t.stableFitRemainingWidth&&(d=t.stableFitMaxMinimapScale),u=Math.min(d,Math.max(1,Math.floor(E/y))),u>i&&(k=Math.min(2,u/i)),O=u/n/k,S=Math.ceil(Math.max(o,f+r)*E),b?(t.stableMinimapLayoutInput=e,t.stableFitRemainingWidth=w,t.stableFitMaxMinimapScale=u):(t.stableMinimapLayoutInput=null,t.stableFitRemainingWidth=0)}}}const I=Math.floor(h*O),L=Math.min(I,Math.max(0,Math.floor((w-m-2)*O/(a+O)))+8);let D=Math.floor(n*L);const W=D/n;D=Math.floor(D*k);return{renderMinimap:c?1:2,minimapLeft:"left"===g?0:o-L-m,minimapWidth:L,minimapHeightIsEditorHeight:z,minimapIsSampling:v,minimapScale:u,minimapLineHeight:E,minimapCanvasInnerWidth:D,minimapCanvasInnerHeight:S,minimapCanvasOuterWidth:W,minimapCanvasOuterHeight:C}}static computeLayout(e,t){const o=0|t.outerWidth,i=0|t.outerHeight,n=0|t.lineHeight,r=0|t.lineNumbersDigitCount,s=t.typicalHalfwidthCharacterWidth,l=t.maxDigitWidth,a=t.pixelRatio,d=t.viewLineCount,c=e.get(125),u="inherit"===c?e.get(124):c,h="inherit"===u?e.get(120):u,p=e.get(123),g=e.get(2),m=t.isDominatedByLongLines,f=e.get(52),w=0!==e.get(62).renderType,b=e.get(63),y=e.get(96),S=e.get(67),C=e.get(94),z=C.verticalScrollbarSize,v=C.verticalHasArrows,E=C.arrowSize,O=C.horizontalScrollbarSize,k=e.get(60),I=e.get(39),L="never"!==e.get(101);let D;if("string"==typeof k&&/^\d+(\.\d+)?ch$/.test(k)){const e=parseFloat(k.substr(0,k.length-2));D=EditorIntOption.clampedInt(e*s,0,0,1e3)}else D=EditorIntOption.clampedInt(k,0,0,1e3);I&&L&&(D+=16);let W=0;if(w){const e=Math.max(r,b);W=Math.round(e*l)}let F=0;f&&(F=n);let x=0,T=x+F,V=T+W,M=V+D;const B=o-F-W-D;let A=!1,H=!1,P=-1;2!==g&&("inherit"===u&&m?(A=!0,H=!0):"on"===h||"bounded"===h?H=!0:"wordWrapColumn"===h&&(P=p));const U=EditorLayoutInfoComputer._computeMinimapLayout({outerWidth:o,outerHeight:i,lineHeight:n,typicalHalfwidthCharacterWidth:s,pixelRatio:a,scrollBeyondLastLine:y,minimap:S,verticalScrollbarWidth:z,viewLineCount:d,remainingWidth:B,isViewportWrapping:H},t.memory||new ComputeOptionsMemory);0!==U.renderMinimap&&0===U.minimapLeft&&(x+=U.minimapWidth,T+=U.minimapWidth,V+=U.minimapWidth,M+=U.minimapWidth);const R=B-U.minimapWidth,_=Math.max(1,Math.floor((R-z-2)/s)),N=v?E:0;return H&&(P=Math.max(1,_),"bounded"===h&&(P=Math.min(P,p))),{width:o,height:i,glyphMarginLeft:x,glyphMarginWidth:F,lineNumbersLeft:T,lineNumbersWidth:W,decorationsLeft:V,decorationsWidth:D,contentLeft:M,contentWidth:R,minimap:U,viewportColumn:_,isWordWrapMinified:A,isViewportWrapping:H,wrappingColumn:P,verticalScrollbarWidth:z,horizontalScrollbarHeight:O,overviewRuler:{top:N,width:z,height:i-2*N,right:0}}}}class EditorLightbulb extends BaseEditorOption{constructor(){const e={enabled:!0};super(59,"lightbulb",e,{"editor.lightbulb.enabled":{type:"boolean",default:e.enabled,description:nls.localize("codeActions","Enables the code action lightbulb in the editor.")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;return{enabled:boolean(e.enabled,this.defaultValue.enabled)}}}class EditorExperimental extends BaseEditorOption{constructor(){const e={stickyScroll:{enabled:!1}};super(34,"experimental",e,{"editor.experimental.stickyScroll.enabled":{type:"boolean",default:e.stickyScroll.enabled,description:nls.localize("editor.experimental.stickyScroll","Shows the nested current scopes during the scroll at the top of the editor.")}})}validate(e){var t;if(!e||"object"!=typeof e)return this.defaultValue;return{stickyScroll:{enabled:boolean(null===(t=e.stickyScroll)||void 0===t?void 0:t.enabled,this.defaultValue.stickyScroll.enabled)}}}}class EditorInlayHints extends BaseEditorOption{constructor(){const e={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",e,{"editor.inlayHints.enabled":{type:"string",default:e.enabled,description:nls.localize("inlayHints.enable","Enables the inlay hints in the editor."),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[nls.localize("editor.inlayHints.on","Inlay hints are enabled"),nls.localize("editor.inlayHints.onUnlessPressed","Inlay hints are showing by default and hide when holding `Ctrl+Alt`"),nls.localize("editor.inlayHints.offUnlessPressed","Inlay hints are hidden by default and show when holding `Ctrl+Alt`"),nls.localize("editor.inlayHints.off","Inlay hints are disabled")]},"editor.inlayHints.fontSize":{type:"number",default:e.fontSize,markdownDescription:nls.localize("inlayHints.fontSize","Controls font size of inlay hints in the editor. As default the {0} is used when the configured value is less than {1} or greater than the editor font size.","`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:e.fontFamily,markdownDescription:nls.localize("inlayHints.fontFamily","Controls font family of inlay hints in the editor. When set to empty, the {0} is used.","`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:e.padding,description:nls.localize("inlayHints.padding","Enables the padding around the inlay hints in the editor.")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return"boolean"==typeof t.enabled&&(t.enabled=t.enabled?"on":"off"),{enabled:stringSet(t.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:EditorIntOption.clampedInt(t.fontSize,this.defaultValue.fontSize,0,100),fontFamily:EditorStringOption.string(t.fontFamily,this.defaultValue.fontFamily),padding:boolean(t.padding,this.defaultValue.padding)}}}class EditorLineHeight extends EditorFloatOption{constructor(){super(61,"lineHeight",EDITOR_FONT_DEFAULTS.lineHeight,(e=>EditorFloatOption.clamp(e,0,150)),{markdownDescription:nls.localize("lineHeight","Controls the line height. \n - Use 0 to automatically compute the line height from the font size.\n - Values between 0 and 8 will be used as a multiplier with the font size.\n - Values greater than or equal to 8 will be used as effective values.")})}compute(e,t,o){return e.fontInfo.lineHeight}}class EditorMinimap extends BaseEditorOption{constructor(){const e={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",e,{"editor.minimap.enabled":{type:"boolean",default:e.enabled,description:nls.localize("minimap.enabled","Controls whether the minimap is shown.")},"editor.minimap.autohide":{type:"boolean",default:e.autohide,description:nls.localize("minimap.autohide","Controls whether the minimap is hidden automatically.")},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[nls.localize("minimap.size.proportional","The minimap has the same size as the editor contents (and might scroll)."),nls.localize("minimap.size.fill","The minimap will stretch or shrink as necessary to fill the height of the editor (no scrolling)."),nls.localize("minimap.size.fit","The minimap will shrink as necessary to never be larger than the editor (no scrolling).")],default:e.size,description:nls.localize("minimap.size","Controls the size of the minimap.")},"editor.minimap.side":{type:"string",enum:["left","right"],default:e.side,description:nls.localize("minimap.side","Controls the side where to render the minimap.")},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:e.showSlider,description:nls.localize("minimap.showSlider","Controls when the minimap slider is shown.")},"editor.minimap.scale":{type:"number",default:e.scale,minimum:1,maximum:3,enum:[1,2,3],description:nls.localize("minimap.scale","Scale of content drawn in the minimap: 1, 2 or 3.")},"editor.minimap.renderCharacters":{type:"boolean",default:e.renderCharacters,description:nls.localize("minimap.renderCharacters","Render the actual characters on a line as opposed to color blocks.")},"editor.minimap.maxColumn":{type:"number",default:e.maxColumn,description:nls.localize("minimap.maxColumn","Limit the width of the minimap to render at most a certain number of columns.")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{enabled:boolean(t.enabled,this.defaultValue.enabled),autohide:boolean(t.autohide,this.defaultValue.autohide),size:stringSet(t.size,this.defaultValue.size,["proportional","fill","fit"]),side:stringSet(t.side,this.defaultValue.side,["right","left"]),showSlider:stringSet(t.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:boolean(t.renderCharacters,this.defaultValue.renderCharacters),scale:EditorIntOption.clampedInt(t.scale,1,1,3),maxColumn:EditorIntOption.clampedInt(t.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function _multiCursorModifierFromString(e){return"ctrlCmd"===e?platform.isMacintosh?"metaKey":"ctrlKey":"altKey"}class EditorPadding extends BaseEditorOption{constructor(){super(77,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:nls.localize("padding.top","Controls the amount of space between the top edge of the editor and the first line.")},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:nls.localize("padding.bottom","Controls the amount of space between the bottom edge of the editor and the last line.")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{top:EditorIntOption.clampedInt(t.top,0,0,1e3),bottom:EditorIntOption.clampedInt(t.bottom,0,0,1e3)}}}class EditorParameterHints extends BaseEditorOption{constructor(){const e={enabled:!0,cycle:!1};super(78,"parameterHints",e,{"editor.parameterHints.enabled":{type:"boolean",default:e.enabled,description:nls.localize("parameterHints.enabled","Enables a pop-up that shows parameter documentation and type information as you type.")},"editor.parameterHints.cycle":{type:"boolean",default:e.cycle,description:nls.localize("parameterHints.cycle","Controls whether the parameter hints menu cycles or closes when reaching the end of the list.")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{enabled:boolean(t.enabled,this.defaultValue.enabled),cycle:boolean(t.cycle,this.defaultValue.cycle)}}}class EditorPixelRatio extends ComputedEditorOption{constructor(){super(131)}compute(e,t,o){return e.pixelRatio}}class EditorQuickSuggestions extends BaseEditorOption{constructor(){const e={other:"on",comments:"off",strings:"off"},t=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[nls.localize("on","Quick suggestions show inside the suggest widget"),nls.localize("inline","Quick suggestions show as ghost text"),nls.localize("off","Quick suggestions are disabled")]}];super(81,"quickSuggestions",e,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:t,default:e.strings,description:nls.localize("quickSuggestions.strings","Enable quick suggestions inside strings.")},comments:{anyOf:t,default:e.comments,description:nls.localize("quickSuggestions.comments","Enable quick suggestions inside comments.")},other:{anyOf:t,default:e.other,description:nls.localize("quickSuggestions.other","Enable quick suggestions outside of strings and comments.")}},default:e,markdownDescription:nls.localize("quickSuggestions","Controls whether suggestions should automatically show up while typing. This can be controlled for typing in comments, strings, and other code. Quick suggestion can be configured to show as ghost text or with the suggest widget. Also be aware of the '{0}'-setting which controls if suggestions are triggered by special characters.","#editor.suggestOnTriggerCharacters#")}),this.defaultValue=e}validate(e){if("boolean"==typeof e){const t=e?"on":"off";return{comments:t,strings:t,other:t}}if(!e||"object"!=typeof e)return this.defaultValue;const{other:t,comments:o,strings:i}=e,n=["on","inline","off"];let r,s,l;return r="boolean"==typeof t?t?"on":"off":stringSet(t,this.defaultValue.other,n),s="boolean"==typeof o?o?"on":"off":stringSet(o,this.defaultValue.comments,n),l="boolean"==typeof i?i?"on":"off":stringSet(i,this.defaultValue.strings,n),{other:r,comments:s,strings:l}}}class EditorRenderLineNumbersOption extends BaseEditorOption{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[nls.localize("lineNumbers.off","Line numbers are not rendered."),nls.localize("lineNumbers.on","Line numbers are rendered as absolute number."),nls.localize("lineNumbers.relative","Line numbers are rendered as distance in lines to cursor position."),nls.localize("lineNumbers.interval","Line numbers are rendered every 10 lines.")],default:"on",description:nls.localize("lineNumbers","Controls the display of line numbers.")})}validate(e){let t=this.defaultValue.renderType,o=this.defaultValue.renderFn;return void 0!==e&&("function"==typeof e?(t=4,o=e):t="interval"===e?3:"relative"===e?2:"on"===e?1:0),{renderType:t,renderFn:o}}}export function filterValidationDecorations(e){const t=e.get(89);return"editable"===t?e.get(83):"on"!==t}class EditorRulers extends BaseEditorOption{constructor(){const e=[],t={type:"number",description:nls.localize("rulers.size","Number of monospace characters at which this editor ruler will render.")};super(93,"rulers",e,{type:"array",items:{anyOf:[t,{type:["object"],properties:{column:t,color:{type:"string",description:nls.localize("rulers.color","Color of this editor ruler."),format:"color-hex"}}}]},default:e,description:nls.localize("rulers","Render vertical rulers after a certain number of monospace characters. Use multiple values for multiple rulers. No rulers are drawn if array is empty.")})}validate(e){if(Array.isArray(e)){const t=[];for(const o of e)if("number"==typeof o)t.push({column:EditorIntOption.clampedInt(o,0,0,1e4),color:null});else if(o&&"object"==typeof o){const e=o;t.push({column:EditorIntOption.clampedInt(e.column,0,0,1e4),color:e.color})}return t.sort(((e,t)=>e.column-t.column)),t}return this.defaultValue}}function _scrollbarVisibilityFromString(e,t){if("string"!=typeof e)return t;switch(e){case"hidden":return 2;case"visible":return 3;default:return 1}}class EditorScrollbar extends BaseEditorOption{constructor(){const e={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(94,"scrollbar",e,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[nls.localize("scrollbar.vertical.auto","The vertical scrollbar will be visible only when necessary."),nls.localize("scrollbar.vertical.visible","The vertical scrollbar will always be visible."),nls.localize("scrollbar.vertical.fit","The vertical scrollbar will always be hidden.")],default:"auto",description:nls.localize("scrollbar.vertical","Controls the visibility of the vertical scrollbar.")},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[nls.localize("scrollbar.horizontal.auto","The horizontal scrollbar will be visible only when necessary."),nls.localize("scrollbar.horizontal.visible","The horizontal scrollbar will always be visible."),nls.localize("scrollbar.horizontal.fit","The horizontal scrollbar will always be hidden.")],default:"auto",description:nls.localize("scrollbar.horizontal","Controls the visibility of the horizontal scrollbar.")},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:e.verticalScrollbarSize,description:nls.localize("scrollbar.verticalScrollbarSize","The width of the vertical scrollbar.")},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:e.horizontalScrollbarSize,description:nls.localize("scrollbar.horizontalScrollbarSize","The height of the horizontal scrollbar.")},"editor.scrollbar.scrollByPage":{type:"boolean",default:e.scrollByPage,description:nls.localize("scrollbar.scrollByPage","Controls whether clicks scroll by page or jump to click position.")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e,o=EditorIntOption.clampedInt(t.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),i=EditorIntOption.clampedInt(t.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:EditorIntOption.clampedInt(t.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:_scrollbarVisibilityFromString(t.vertical,this.defaultValue.vertical),horizontal:_scrollbarVisibilityFromString(t.horizontal,this.defaultValue.horizontal),useShadows:boolean(t.useShadows,this.defaultValue.useShadows),verticalHasArrows:boolean(t.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:boolean(t.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:boolean(t.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:boolean(t.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:o,horizontalSliderSize:EditorIntOption.clampedInt(t.horizontalSliderSize,o,0,1e3),verticalScrollbarSize:i,verticalSliderSize:EditorIntOption.clampedInt(t.verticalSliderSize,i,0,1e3),scrollByPage:boolean(t.scrollByPage,this.defaultValue.scrollByPage)}}}export const inUntrustedWorkspace="inUntrustedWorkspace";export const unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class UnicodeHighlight extends BaseEditorOption{constructor(){const e={nonBasicASCII:inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",e,{[unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,inUntrustedWorkspace],default:e.nonBasicASCII,description:nls.localize("unicodeHighlight.nonBasicASCII","Controls whether all non-basic ASCII characters are highlighted. Only characters between U+0020 and U+007E, tab, line-feed and carriage-return are considered basic ASCII.")},[unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:e.invisibleCharacters,description:nls.localize("unicodeHighlight.invisibleCharacters","Controls whether characters that just reserve space or have no width at all are highlighted.")},[unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:e.ambiguousCharacters,description:nls.localize("unicodeHighlight.ambiguousCharacters","Controls whether characters are highlighted that can be confused with basic ASCII characters, except those that are common in the current user locale.")},[unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,inUntrustedWorkspace],default:e.includeComments,description:nls.localize("unicodeHighlight.includeComments","Controls whether characters in comments should also be subject to unicode highlighting.")},[unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,inUntrustedWorkspace],default:e.includeStrings,description:nls.localize("unicodeHighlight.includeStrings","Controls whether characters in strings should also be subject to unicode highlighting.")},[unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:e.allowedCharacters,description:nls.localize("unicodeHighlight.allowedCharacters","Defines allowed characters that are not being highlighted."),additionalProperties:{type:"boolean"}},[unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:e.allowedLocales,description:nls.localize("unicodeHighlight.allowedLocales","Unicode characters that are common in allowed locales are not being highlighted.")}})}applyUpdate(e,t){let o=!1;t.allowedCharacters&&e&&(objects.equals(e.allowedCharacters,t.allowedCharacters)||(e=Object.assign(Object.assign({},e),{allowedCharacters:t.allowedCharacters}),o=!0)),t.allowedLocales&&e&&(objects.equals(e.allowedLocales,t.allowedLocales)||(e=Object.assign(Object.assign({},e),{allowedLocales:t.allowedLocales}),o=!0));const i=super.applyUpdate(e,t);return o?new ApplyUpdateResult(i.newValue,!0):i}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{nonBasicASCII:primitiveSet(t.nonBasicASCII,inUntrustedWorkspace,[!0,!1,inUntrustedWorkspace]),invisibleCharacters:boolean(t.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:boolean(t.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:primitiveSet(t.includeComments,inUntrustedWorkspace,[!0,!1,inUntrustedWorkspace]),includeStrings:primitiveSet(t.includeStrings,inUntrustedWorkspace,[!0,!1,inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(e.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(e.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(e,t){if("object"!=typeof e||!e)return t;const o={};for(const[t,i]of Object.entries(e))!0===i&&(o[t]=!0);return o}}class InlineEditorSuggest extends BaseEditorOption{constructor(){const e={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",e,{"editor.inlineSuggest.enabled":{type:"boolean",default:e.enabled,description:nls.localize("inlineSuggest.enabled","Controls whether to automatically show inline suggestions in the editor.")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{enabled:boolean(t.enabled,this.defaultValue.enabled),mode:stringSet(t.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class BracketPairColorization extends BaseEditorOption{constructor(){const e={enabled:EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",e,{"editor.bracketPairColorization.enabled":{type:"boolean",default:e.enabled,markdownDescription:nls.localize("bracketPairColorization.enabled","Controls whether bracket pair colorization is enabled or not. Use {0} to override the bracket highlight colors.","`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:e.independentColorPoolPerBracketType,description:nls.localize("bracketPairColorization.independentColorPoolPerBracketType","Controls whether each bracket type has its own independent color pool.")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{enabled:boolean(t.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:boolean(t.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class GuideOptions extends BaseEditorOption{constructor(){const e={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",e,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[nls.localize("editor.guides.bracketPairs.true","Enables bracket pair guides."),nls.localize("editor.guides.bracketPairs.active","Enables bracket pair guides only for the active bracket pair."),nls.localize("editor.guides.bracketPairs.false","Disables bracket pair guides.")],default:e.bracketPairs,description:nls.localize("editor.guides.bracketPairs","Controls whether bracket pair guides are enabled or not.")},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[nls.localize("editor.guides.bracketPairsHorizontal.true","Enables horizontal guides as addition to vertical bracket pair guides."),nls.localize("editor.guides.bracketPairsHorizontal.active","Enables horizontal guides only for the active bracket pair."),nls.localize("editor.guides.bracketPairsHorizontal.false","Disables horizontal bracket pair guides.")],default:e.bracketPairsHorizontal,description:nls.localize("editor.guides.bracketPairsHorizontal","Controls whether horizontal bracket pair guides are enabled or not.")},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:e.highlightActiveBracketPair,description:nls.localize("editor.guides.highlightActiveBracketPair","Controls whether the editor should highlight the active bracket pair.")},"editor.guides.indentation":{type:"boolean",default:e.indentation,description:nls.localize("editor.guides.indentation","Controls whether the editor should render indent guides.")},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[nls.localize("editor.guides.highlightActiveIndentation.true","Highlights the active indent guide."),nls.localize("editor.guides.highlightActiveIndentation.always","Highlights the active indent guide even if bracket guides are highlighted."),nls.localize("editor.guides.highlightActiveIndentation.false","Do not highlight the active indent guide.")],default:e.highlightActiveIndentation,description:nls.localize("editor.guides.highlightActiveIndentation","Controls whether the editor should highlight the active indent guide.")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{bracketPairs:primitiveSet(t.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:primitiveSet(t.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:boolean(t.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:boolean(t.indentation,this.defaultValue.indentation),highlightActiveIndentation:primitiveSet(t.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function primitiveSet(e,t,o){const i=o.indexOf(e);return-1===i?t:o[i]}class EditorSuggest extends BaseEditorOption{constructor(){const e={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",e,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[nls.localize("suggest.insertMode.insert","Insert suggestion without overwriting text right of the cursor."),nls.localize("suggest.insertMode.replace","Insert suggestion and overwrite text right of the cursor.")],default:e.insertMode,description:nls.localize("suggest.insertMode","Controls whether words are overwritten when accepting completions. Note that this depends on extensions opting into this feature.")},"editor.suggest.filterGraceful":{type:"boolean",default:e.filterGraceful,description:nls.localize("suggest.filterGraceful","Controls whether filtering and sorting suggestions accounts for small typos.")},"editor.suggest.localityBonus":{type:"boolean",default:e.localityBonus,description:nls.localize("suggest.localityBonus","Controls whether sorting favors words that appear close to the cursor.")},"editor.suggest.shareSuggestSelections":{type:"boolean",default:e.shareSuggestSelections,markdownDescription:nls.localize("suggest.shareSuggestSelections","Controls whether remembered suggestion selections are shared between multiple workspaces and windows (needs `#editor.suggestSelection#`).")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:e.snippetsPreventQuickSuggestions,description:nls.localize("suggest.snippetsPreventQuickSuggestions","Controls whether an active snippet prevents quick suggestions.")},"editor.suggest.showIcons":{type:"boolean",default:e.showIcons,description:nls.localize("suggest.showIcons","Controls whether to show or hide icons in suggestions.")},"editor.suggest.showStatusBar":{type:"boolean",default:e.showStatusBar,description:nls.localize("suggest.showStatusBar","Controls the visibility of the status bar at the bottom of the suggest widget.")},"editor.suggest.preview":{type:"boolean",default:e.preview,description:nls.localize("suggest.preview","Controls whether to preview the suggestion outcome in the editor.")},"editor.suggest.showInlineDetails":{type:"boolean",default:e.showInlineDetails,description:nls.localize("suggest.showInlineDetails","Controls whether suggest details show inline with the label or only in the details widget")},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:nls.localize("suggest.maxVisibleSuggestions.dep","This setting is deprecated. The suggest widget can now be resized.")},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:nls.localize("deprecated","This setting is deprecated, please use separate settings like 'editor.suggest.showKeywords' or 'editor.suggest.showSnippets' instead.")},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showMethods","When enabled IntelliSense shows `method`-suggestions.")},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showFunctions","When enabled IntelliSense shows `function`-suggestions.")},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showConstructors","When enabled IntelliSense shows `constructor`-suggestions.")},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showDeprecated","When enabled IntelliSense shows `deprecated`-suggestions.")},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showFields","When enabled IntelliSense shows `field`-suggestions.")},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showVariables","When enabled IntelliSense shows `variable`-suggestions.")},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showClasss","When enabled IntelliSense shows `class`-suggestions.")},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showStructs","When enabled IntelliSense shows `struct`-suggestions.")},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showInterfaces","When enabled IntelliSense shows `interface`-suggestions.")},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showModules","When enabled IntelliSense shows `module`-suggestions.")},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showPropertys","When enabled IntelliSense shows `property`-suggestions.")},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showEvents","When enabled IntelliSense shows `event`-suggestions.")},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showOperators","When enabled IntelliSense shows `operator`-suggestions.")},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showUnits","When enabled IntelliSense shows `unit`-suggestions.")},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showValues","When enabled IntelliSense shows `value`-suggestions.")},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showConstants","When enabled IntelliSense shows `constant`-suggestions.")},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showEnums","When enabled IntelliSense shows `enum`-suggestions.")},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showEnumMembers","When enabled IntelliSense shows `enumMember`-suggestions.")},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showKeywords","When enabled IntelliSense shows `keyword`-suggestions.")},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showTexts","When enabled IntelliSense shows `text`-suggestions.")},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showColors","When enabled IntelliSense shows `color`-suggestions.")},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showFiles","When enabled IntelliSense shows `file`-suggestions.")},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showReferences","When enabled IntelliSense shows `reference`-suggestions.")},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showCustomcolors","When enabled IntelliSense shows `customcolor`-suggestions.")},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showFolders","When enabled IntelliSense shows `folder`-suggestions.")},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showTypeParameters","When enabled IntelliSense shows `typeParameter`-suggestions.")},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showSnippets","When enabled IntelliSense shows `snippet`-suggestions.")},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showUsers","When enabled IntelliSense shows `user`-suggestions.")},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:nls.localize("editor.suggest.showIssues","When enabled IntelliSense shows `issues`-suggestions.")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{insertMode:stringSet(t.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:boolean(t.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:boolean(t.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:boolean(t.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:boolean(t.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:boolean(t.showIcons,this.defaultValue.showIcons),showStatusBar:boolean(t.showStatusBar,this.defaultValue.showStatusBar),preview:boolean(t.preview,this.defaultValue.preview),previewMode:stringSet(t.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:boolean(t.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:boolean(t.showMethods,this.defaultValue.showMethods),showFunctions:boolean(t.showFunctions,this.defaultValue.showFunctions),showConstructors:boolean(t.showConstructors,this.defaultValue.showConstructors),showDeprecated:boolean(t.showDeprecated,this.defaultValue.showDeprecated),showFields:boolean(t.showFields,this.defaultValue.showFields),showVariables:boolean(t.showVariables,this.defaultValue.showVariables),showClasses:boolean(t.showClasses,this.defaultValue.showClasses),showStructs:boolean(t.showStructs,this.defaultValue.showStructs),showInterfaces:boolean(t.showInterfaces,this.defaultValue.showInterfaces),showModules:boolean(t.showModules,this.defaultValue.showModules),showProperties:boolean(t.showProperties,this.defaultValue.showProperties),showEvents:boolean(t.showEvents,this.defaultValue.showEvents),showOperators:boolean(t.showOperators,this.defaultValue.showOperators),showUnits:boolean(t.showUnits,this.defaultValue.showUnits),showValues:boolean(t.showValues,this.defaultValue.showValues),showConstants:boolean(t.showConstants,this.defaultValue.showConstants),showEnums:boolean(t.showEnums,this.defaultValue.showEnums),showEnumMembers:boolean(t.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:boolean(t.showKeywords,this.defaultValue.showKeywords),showWords:boolean(t.showWords,this.defaultValue.showWords),showColors:boolean(t.showColors,this.defaultValue.showColors),showFiles:boolean(t.showFiles,this.defaultValue.showFiles),showReferences:boolean(t.showReferences,this.defaultValue.showReferences),showFolders:boolean(t.showFolders,this.defaultValue.showFolders),showTypeParameters:boolean(t.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:boolean(t.showSnippets,this.defaultValue.showSnippets),showUsers:boolean(t.showUsers,this.defaultValue.showUsers),showIssues:boolean(t.showIssues,this.defaultValue.showIssues)}}}class SmartSelect extends BaseEditorOption{constructor(){super(104,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:nls.localize("selectLeadingAndTrailingWhitespace","Whether leading and trailing whitespace should always be selected."),default:!0,type:"boolean"}})}validate(e){return e&&"object"==typeof e?{selectLeadingAndTrailingWhitespace:boolean(e.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}:this.defaultValue}}class EditorTabFocusMode extends ComputedEditorOption{constructor(){super(132)}compute(e,t,o){return!!t.get(83)||e.tabFocusMode}}function _wrappingIndentFromString(e){switch(e){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class EditorWrappingInfoComputer extends ComputedEditorOption{constructor(){super(134)}compute(e,t,o){const i=t.get(133);return{isDominatedByLongLines:e.isDominatedByLongLines,isWordWrapMinified:i.isWordWrapMinified,isViewportWrapping:i.isViewportWrapping,wrappingColumn:i.wrappingColumn}}}class EditorDropIntoEditor extends BaseEditorOption{constructor(){const e={enabled:!0};super(32,"dropIntoEditor",e,{"editor.dropIntoEditor.enabled":{type:"boolean",default:e.enabled,markdownDescription:nls.localize("dropIntoEditor.enabled","Controls whether you can drag and drop a file into a text editor by holding down `shift` (instead of opening the file in an editor).")}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;return{enabled:boolean(e.enabled,this.defaultValue.enabled)}}}const DEFAULT_WINDOWS_FONT_FAMILY="Consolas, 'Courier New', monospace",DEFAULT_MAC_FONT_FAMILY="Menlo, Monaco, 'Courier New', monospace",DEFAULT_LINUX_FONT_FAMILY="'Droid Sans Mono', 'monospace', monospace";export const EDITOR_FONT_DEFAULTS={fontFamily:platform.isMacintosh?DEFAULT_MAC_FONT_FAMILY:platform.isLinux?DEFAULT_LINUX_FONT_FAMILY:DEFAULT_WINDOWS_FONT_FAMILY,fontWeight:"normal",fontSize:platform.isMacintosh?12:14,lineHeight:0,letterSpacing:0};export const editorOptionsRegistry=[];function register(e){return editorOptionsRegistry[e.id]=e,e}export const EditorOptions={acceptSuggestionOnCommitCharacter:register(new EditorBooleanOption(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:nls.localize("acceptSuggestionOnCommitCharacter","Controls whether suggestions should be accepted on commit characters. For example, in JavaScript, the semi-colon (`; `) can be a commit character that accepts a suggestion and types that character.")})),acceptSuggestionOnEnter:register(new EditorStringEnumOption(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",nls.localize("acceptSuggestionOnEnterSmart","Only accept a suggestion with `Enter` when it makes a textual change."),""],markdownDescription:nls.localize("acceptSuggestionOnEnter","Controls whether suggestions should be accepted on `Enter`, in addition to `Tab`. Helps to avoid ambiguity between inserting new lines or accepting suggestions.")})),accessibilitySupport:register(new EditorAccessibilitySupport),accessibilityPageSize:register(new EditorIntOption(3,"accessibilityPageSize",10,1,1073741824,{description:nls.localize("accessibilityPageSize","Controls the number of lines in the editor that can be read out by a screen reader at once. When we detect a screen reader we automatically set the default to be 500. Warning: this has a performance implication for numbers larger than the default.")})),ariaLabel:register(new EditorStringOption(4,"ariaLabel",nls.localize("editorViewAccessibleLabel","Editor content"))),autoClosingBrackets:register(new EditorStringEnumOption(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",nls.localize("editor.autoClosingBrackets.languageDefined","Use language configurations to determine when to autoclose brackets."),nls.localize("editor.autoClosingBrackets.beforeWhitespace","Autoclose brackets only when the cursor is to the left of whitespace."),""],description:nls.localize("autoClosingBrackets","Controls whether the editor should automatically close brackets after the user adds an opening bracket.")})),autoClosingDelete:register(new EditorStringEnumOption(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",nls.localize("editor.autoClosingDelete.auto","Remove adjacent closing quotes or brackets only if they were automatically inserted."),""],description:nls.localize("autoClosingDelete","Controls whether the editor should remove adjacent closing quotes or brackets when deleting.")})),autoClosingOvertype:register(new EditorStringEnumOption(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",nls.localize("editor.autoClosingOvertype.auto","Type over closing quotes or brackets only if they were automatically inserted."),""],description:nls.localize("autoClosingOvertype","Controls whether the editor should type over closing quotes or brackets.")})),autoClosingQuotes:register(new EditorStringEnumOption(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",nls.localize("editor.autoClosingQuotes.languageDefined","Use language configurations to determine when to autoclose quotes."),nls.localize("editor.autoClosingQuotes.beforeWhitespace","Autoclose quotes only when the cursor is to the left of whitespace."),""],description:nls.localize("autoClosingQuotes","Controls whether the editor should automatically close quotes after the user adds an opening quote.")})),autoIndent:register(new EditorEnumOption(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],_autoIndentFromString,{enumDescriptions:[nls.localize("editor.autoIndent.none","The editor will not insert indentation automatically."),nls.localize("editor.autoIndent.keep","The editor will keep the current line's indentation."),nls.localize("editor.autoIndent.brackets","The editor will keep the current line's indentation and honor language defined brackets."),nls.localize("editor.autoIndent.advanced","The editor will keep the current line's indentation, honor language defined brackets and invoke special onEnterRules defined by languages."),nls.localize("editor.autoIndent.full","The editor will keep the current line's indentation, honor language defined brackets, invoke special onEnterRules defined by languages, and honor indentationRules defined by languages.")],description:nls.localize("autoIndent","Controls whether the editor should automatically adjust the indentation when users type, paste, move or indent lines.")})),automaticLayout:register(new EditorBooleanOption(10,"automaticLayout",!1)),autoSurround:register(new EditorStringEnumOption(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[nls.localize("editor.autoSurround.languageDefined","Use language configurations to determine when to automatically surround selections."),nls.localize("editor.autoSurround.quotes","Surround with quotes but not brackets."),nls.localize("editor.autoSurround.brackets","Surround with brackets but not quotes."),""],description:nls.localize("autoSurround","Controls whether the editor should automatically surround selections when typing quotes or brackets.")})),bracketPairColorization:register(new BracketPairColorization),bracketPairGuides:register(new GuideOptions),stickyTabStops:register(new EditorBooleanOption(106,"stickyTabStops",!1,{description:nls.localize("stickyTabStops","Emulate selection behavior of tab characters when using spaces for indentation. Selection will stick to tab stops.")})),codeLens:register(new EditorBooleanOption(14,"codeLens",!0,{description:nls.localize("codeLens","Controls whether the editor shows CodeLens.")})),codeLensFontFamily:register(new EditorStringOption(15,"codeLensFontFamily","",{description:nls.localize("codeLensFontFamily","Controls the font family for CodeLens.")})),codeLensFontSize:register(new EditorIntOption(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:nls.localize("codeLensFontSize","Controls the font size in pixels for CodeLens. When set to `0`, 90% of `#editor.fontSize#` is used.")})),colorDecorators:register(new EditorBooleanOption(17,"colorDecorators",!0,{description:nls.localize("colorDecorators","Controls whether the editor should render the inline color decorators and color picker.")})),columnSelection:register(new EditorBooleanOption(18,"columnSelection",!1,{description:nls.localize("columnSelection","Enable that the selection with the mouse and keys is doing column selection.")})),comments:register(new EditorComments),contextmenu:register(new EditorBooleanOption(20,"contextmenu",!0)),copyWithSyntaxHighlighting:register(new EditorBooleanOption(21,"copyWithSyntaxHighlighting",!0,{description:nls.localize("copyWithSyntaxHighlighting","Controls whether syntax highlighting should be copied into the clipboard.")})),cursorBlinking:register(new EditorEnumOption(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],_cursorBlinkingStyleFromString,{description:nls.localize("cursorBlinking","Control the cursor animation style.")})),cursorSmoothCaretAnimation:register(new EditorBooleanOption(23,"cursorSmoothCaretAnimation",!1,{description:nls.localize("cursorSmoothCaretAnimation","Controls whether the smooth caret animation should be enabled.")})),cursorStyle:register(new EditorEnumOption(24,"cursorStyle",TextEditorCursorStyle.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],_cursorStyleFromString,{description:nls.localize("cursorStyle","Controls the cursor style.")})),cursorSurroundingLines:register(new EditorIntOption(25,"cursorSurroundingLines",0,0,1073741824,{description:nls.localize("cursorSurroundingLines","Controls the minimal number of visible leading and trailing lines surrounding the cursor. Known as 'scrollOff' or 'scrollOffset' in some other editors.")})),cursorSurroundingLinesStyle:register(new EditorStringEnumOption(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[nls.localize("cursorSurroundingLinesStyle.default","`cursorSurroundingLines` is enforced only when triggered via the keyboard or API."),nls.localize("cursorSurroundingLinesStyle.all","`cursorSurroundingLines` is enforced always.")],description:nls.localize("cursorSurroundingLinesStyle","Controls when `cursorSurroundingLines` should be enforced.")})),cursorWidth:register(new EditorIntOption(27,"cursorWidth",0,0,1073741824,{markdownDescription:nls.localize("cursorWidth","Controls the width of the cursor when `#editor.cursorStyle#` is set to `line`.")})),disableLayerHinting:register(new EditorBooleanOption(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:register(new EditorBooleanOption(29,"disableMonospaceOptimizations",!1)),domReadOnly:register(new EditorBooleanOption(30,"domReadOnly",!1)),dragAndDrop:register(new EditorBooleanOption(31,"dragAndDrop",!0,{description:nls.localize("dragAndDrop","Controls whether the editor should allow moving selections via drag and drop.")})),emptySelectionClipboard:register(new EditorEmptySelectionClipboard),dropIntoEditor:register(new EditorDropIntoEditor),experimental:register(new EditorExperimental),extraEditorClassName:register(new EditorStringOption(35,"extraEditorClassName","")),fastScrollSensitivity:register(new EditorFloatOption(36,"fastScrollSensitivity",5,(e=>e<=0?5:e),{markdownDescription:nls.localize("fastScrollSensitivity","Scrolling speed multiplier when pressing `Alt`.")})),find:register(new EditorFind),fixedOverflowWidgets:register(new EditorBooleanOption(38,"fixedOverflowWidgets",!1)),folding:register(new EditorBooleanOption(39,"folding",!0,{description:nls.localize("folding","Controls whether the editor has code folding enabled.")})),foldingStrategy:register(new EditorStringEnumOption(40,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[nls.localize("foldingStrategy.auto","Use a language-specific folding strategy if available, else the indentation-based one."),nls.localize("foldingStrategy.indentation","Use the indentation-based folding strategy.")],description:nls.localize("foldingStrategy","Controls the strategy for computing folding ranges.")})),foldingHighlight:register(new EditorBooleanOption(41,"foldingHighlight",!0,{description:nls.localize("foldingHighlight","Controls whether the editor should highlight folded ranges.")})),foldingImportsByDefault:register(new EditorBooleanOption(42,"foldingImportsByDefault",!1,{description:nls.localize("foldingImportsByDefault","Controls whether the editor automatically collapses import ranges.")})),foldingMaximumRegions:register(new EditorIntOption(43,"foldingMaximumRegions",5e3,10,65e3,{description:nls.localize("foldingMaximumRegions","The maximum number of foldable regions. Increasing this value may result in the editor becoming less responsive when the current source has a large number of foldable regions.")})),unfoldOnClickAfterEndOfLine:register(new EditorBooleanOption(44,"unfoldOnClickAfterEndOfLine",!1,{description:nls.localize("unfoldOnClickAfterEndOfLine","Controls whether clicking on the empty content after a folded line will unfold the line.")})),fontFamily:register(new EditorStringOption(45,"fontFamily",EDITOR_FONT_DEFAULTS.fontFamily,{description:nls.localize("fontFamily","Controls the font family.")})),fontInfo:register(new EditorFontInfo),fontLigatures2:register(new EditorFontLigatures),fontSize:register(new EditorFontSize),fontWeight:register(new EditorFontWeight),formatOnPaste:register(new EditorBooleanOption(50,"formatOnPaste",!1,{description:nls.localize("formatOnPaste","Controls whether the editor should automatically format the pasted content. A formatter must be available and the formatter should be able to format a range in a document.")})),formatOnType:register(new EditorBooleanOption(51,"formatOnType",!1,{description:nls.localize("formatOnType","Controls whether the editor should automatically format the line after typing.")})),glyphMargin:register(new EditorBooleanOption(52,"glyphMargin",!0,{description:nls.localize("glyphMargin","Controls whether the editor should render the vertical glyph margin. Glyph margin is mostly used for debugging.")})),gotoLocation:register(new EditorGoToLocation),hideCursorInOverviewRuler:register(new EditorBooleanOption(54,"hideCursorInOverviewRuler",!1,{description:nls.localize("hideCursorInOverviewRuler","Controls whether the cursor should be hidden in the overview ruler.")})),hover:register(new EditorHover),inDiffEditor:register(new EditorBooleanOption(56,"inDiffEditor",!1)),letterSpacing:register(new EditorFloatOption(58,"letterSpacing",EDITOR_FONT_DEFAULTS.letterSpacing,(e=>EditorFloatOption.clamp(e,-5,20)),{description:nls.localize("letterSpacing","Controls the letter spacing in pixels.")})),lightbulb:register(new EditorLightbulb),lineDecorationsWidth:register(new SimpleEditorOption(60,"lineDecorationsWidth",10)),lineHeight:register(new EditorLineHeight),lineNumbers:register(new EditorRenderLineNumbersOption),lineNumbersMinChars:register(new EditorIntOption(63,"lineNumbersMinChars",5,1,300)),linkedEditing:register(new EditorBooleanOption(64,"linkedEditing",!1,{description:nls.localize("linkedEditing","Controls whether the editor has linked editing enabled. Depending on the language, related symbols, e.g. HTML tags, are updated while editing.")})),links:register(new EditorBooleanOption(65,"links",!0,{description:nls.localize("links","Controls whether the editor should detect links and make them clickable.")})),matchBrackets:register(new EditorStringEnumOption(66,"matchBrackets","always",["always","near","never"],{description:nls.localize("matchBrackets","Highlight matching brackets.")})),minimap:register(new EditorMinimap),mouseStyle:register(new EditorStringEnumOption(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:register(new EditorFloatOption(69,"mouseWheelScrollSensitivity",1,(e=>0===e?1:e),{markdownDescription:nls.localize("mouseWheelScrollSensitivity","A multiplier to be used on the `deltaX` and `deltaY` of mouse wheel scroll events.")})),mouseWheelZoom:register(new EditorBooleanOption(70,"mouseWheelZoom",!1,{markdownDescription:nls.localize("mouseWheelZoom","Zoom the font of the editor when using mouse wheel and holding `Ctrl`.")})),multiCursorMergeOverlapping:register(new EditorBooleanOption(71,"multiCursorMergeOverlapping",!0,{description:nls.localize("multiCursorMergeOverlapping","Merge multiple cursors when they are overlapping.")})),multiCursorModifier:register(new EditorEnumOption(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],_multiCursorModifierFromString,{markdownEnumDescriptions:[nls.localize("multiCursorModifier.ctrlCmd","Maps to `Control` on Windows and Linux and to `Command` on macOS."),nls.localize("multiCursorModifier.alt","Maps to `Alt` on Windows and Linux and to `Option` on macOS.")],markdownDescription:nls.localize({key:"multiCursorModifier",comment:["- `ctrlCmd` refers to a value the setting can take and should not be localized.","- `Control` and `Command` refer to the modifier keys Ctrl or Cmd on the keyboard and can be localized."]},"The modifier to be used to add multiple cursors with the mouse. The Go to Definition and Open Link mouse gestures will adapt such that they do not conflict with the [multicursor modifier](https://code.visualstudio.com/docs/editor/codebasics#_multicursor-modifier).")})),multiCursorPaste:register(new EditorStringEnumOption(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[nls.localize("multiCursorPaste.spread","Each cursor pastes a single line of the text."),nls.localize("multiCursorPaste.full","Each cursor pastes the full text.")],markdownDescription:nls.localize("multiCursorPaste","Controls pasting when the line count of the pasted text matches the cursor count.")})),occurrencesHighlight:register(new EditorBooleanOption(74,"occurrencesHighlight",!0,{description:nls.localize("occurrencesHighlight","Controls whether the editor should highlight semantic symbol occurrences.")})),overviewRulerBorder:register(new EditorBooleanOption(75,"overviewRulerBorder",!0,{description:nls.localize("overviewRulerBorder","Controls whether a border should be drawn around the overview ruler.")})),overviewRulerLanes:register(new EditorIntOption(76,"overviewRulerLanes",3,0,3)),padding:register(new EditorPadding),parameterHints:register(new EditorParameterHints),peekWidgetDefaultFocus:register(new EditorStringEnumOption(79,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[nls.localize("peekWidgetDefaultFocus.tree","Focus the tree when opening peek"),nls.localize("peekWidgetDefaultFocus.editor","Focus the editor when opening peek")],description:nls.localize("peekWidgetDefaultFocus","Controls whether to focus the inline editor or the tree in the peek widget.")})),definitionLinkOpensInPeek:register(new EditorBooleanOption(80,"definitionLinkOpensInPeek",!1,{description:nls.localize("definitionLinkOpensInPeek","Controls whether the Go to Definition mouse gesture always opens the peek widget.")})),quickSuggestions:register(new EditorQuickSuggestions),quickSuggestionsDelay:register(new EditorIntOption(82,"quickSuggestionsDelay",10,0,1073741824,{description:nls.localize("quickSuggestionsDelay","Controls the delay in milliseconds after which quick suggestions will show up.")})),readOnly:register(new EditorBooleanOption(83,"readOnly",!1)),renameOnType:register(new EditorBooleanOption(84,"renameOnType",!1,{description:nls.localize("renameOnType","Controls whether the editor auto renames on type."),markdownDeprecationMessage:nls.localize("renameOnTypeDeprecate","Deprecated, use `editor.linkedEditing` instead.")})),renderControlCharacters:register(new EditorBooleanOption(85,"renderControlCharacters",!0,{description:nls.localize("renderControlCharacters","Controls whether the editor should render control characters."),restricted:!0})),renderFinalNewline:register(new EditorBooleanOption(86,"renderFinalNewline",!0,{description:nls.localize("renderFinalNewline","Render last line number when the file ends with a newline.")})),renderLineHighlight:register(new EditorStringEnumOption(87,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",nls.localize("renderLineHighlight.all","Highlights both the gutter and the current line.")],description:nls.localize("renderLineHighlight","Controls how the editor should render the current line highlight.")})),renderLineHighlightOnlyWhenFocus:register(new EditorBooleanOption(88,"renderLineHighlightOnlyWhenFocus",!1,{description:nls.localize("renderLineHighlightOnlyWhenFocus","Controls if the editor should render the current line highlight only when the editor is focused.")})),renderValidationDecorations:register(new EditorStringEnumOption(89,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:register(new EditorStringEnumOption(90,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",nls.localize("renderWhitespace.boundary","Render whitespace characters except for single spaces between words."),nls.localize("renderWhitespace.selection","Render whitespace characters only on selected text."),nls.localize("renderWhitespace.trailing","Render only trailing whitespace characters."),""],description:nls.localize("renderWhitespace","Controls how the editor should render whitespace characters.")})),revealHorizontalRightPadding:register(new EditorIntOption(91,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:register(new EditorBooleanOption(92,"roundedSelection",!0,{description:nls.localize("roundedSelection","Controls whether selections should have rounded corners.")})),rulers:register(new EditorRulers),scrollbar:register(new EditorScrollbar),scrollBeyondLastColumn:register(new EditorIntOption(95,"scrollBeyondLastColumn",4,0,1073741824,{description:nls.localize("scrollBeyondLastColumn","Controls the number of extra characters beyond which the editor will scroll horizontally.")})),scrollBeyondLastLine:register(new EditorBooleanOption(96,"scrollBeyondLastLine",!0,{description:nls.localize("scrollBeyondLastLine","Controls whether the editor will scroll beyond the last line.")})),scrollPredominantAxis:register(new EditorBooleanOption(97,"scrollPredominantAxis",!0,{description:nls.localize("scrollPredominantAxis","Scroll only along the predominant axis when scrolling both vertically and horizontally at the same time. Prevents horizontal drift when scrolling vertically on a trackpad.")})),selectionClipboard:register(new EditorBooleanOption(98,"selectionClipboard",!0,{description:nls.localize("selectionClipboard","Controls whether the Linux primary clipboard should be supported."),included:platform.isLinux})),selectionHighlight:register(new EditorBooleanOption(99,"selectionHighlight",!0,{description:nls.localize("selectionHighlight","Controls whether the editor should highlight matches similar to the selection.")})),selectOnLineNumbers:register(new EditorBooleanOption(100,"selectOnLineNumbers",!0)),showFoldingControls:register(new EditorStringEnumOption(101,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[nls.localize("showFoldingControls.always","Always show the folding controls."),nls.localize("showFoldingControls.never","Never show the folding controls and reduce the gutter size."),nls.localize("showFoldingControls.mouseover","Only show the folding controls when the mouse is over the gutter.")],description:nls.localize("showFoldingControls","Controls when the folding controls on the gutter are shown.")})),showUnused:register(new EditorBooleanOption(102,"showUnused",!0,{description:nls.localize("showUnused","Controls fading out of unused code.")})),showDeprecated:register(new EditorBooleanOption(128,"showDeprecated",!0,{description:nls.localize("showDeprecated","Controls strikethrough deprecated variables.")})),inlayHints:register(new EditorInlayHints),snippetSuggestions:register(new EditorStringEnumOption(103,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[nls.localize("snippetSuggestions.top","Show snippet suggestions on top of other suggestions."),nls.localize("snippetSuggestions.bottom","Show snippet suggestions below other suggestions."),nls.localize("snippetSuggestions.inline","Show snippets suggestions with other suggestions."),nls.localize("snippetSuggestions.none","Do not show snippet suggestions.")],description:nls.localize("snippetSuggestions","Controls whether snippets are shown with other suggestions and how they are sorted.")})),smartSelect:register(new SmartSelect),smoothScrolling:register(new EditorBooleanOption(105,"smoothScrolling",!1,{description:nls.localize("smoothScrolling","Controls whether the editor will scroll using an animation.")})),stopRenderingLineAfter:register(new EditorIntOption(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:register(new EditorSuggest),inlineSuggest:register(new InlineEditorSuggest),suggestFontSize:register(new EditorIntOption(109,"suggestFontSize",0,0,1e3,{markdownDescription:nls.localize("suggestFontSize","Font size for the suggest widget. When set to {0}, the value of {1} is used.","`0`","`#editor.fontSize#`")})),suggestLineHeight:register(new EditorIntOption(110,"suggestLineHeight",0,0,1e3,{markdownDescription:nls.localize("suggestLineHeight","Line height for the suggest widget. When set to {0}, the value of {1} is used. The minimum value is 8.","`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:register(new EditorBooleanOption(111,"suggestOnTriggerCharacters",!0,{description:nls.localize("suggestOnTriggerCharacters","Controls whether suggestions should automatically show up when typing trigger characters.")})),suggestSelection:register(new EditorStringEnumOption(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[nls.localize("suggestSelection.first","Always select the first suggestion."),nls.localize("suggestSelection.recentlyUsed","Select recent suggestions unless further typing selects one, e.g. `console.| -> console.log` because `log` has been completed recently."),nls.localize("suggestSelection.recentlyUsedByPrefix","Select suggestions based on previous prefixes that have completed those suggestions, e.g. `co -> console` and `con -> const`.")],description:nls.localize("suggestSelection","Controls how suggestions are pre-selected when showing the suggest list.")})),tabCompletion:register(new EditorStringEnumOption(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[nls.localize("tabCompletion.on","Tab complete will insert the best matching suggestion when pressing tab."),nls.localize("tabCompletion.off","Disable tab completions."),nls.localize("tabCompletion.onlySnippets","Tab complete snippets when their prefix match. Works best when 'quickSuggestions' aren't enabled.")],description:nls.localize("tabCompletion","Enables tab completions.")})),tabIndex:register(new EditorIntOption(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:register(new UnicodeHighlight),unusualLineTerminators:register(new EditorStringEnumOption(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[nls.localize("unusualLineTerminators.auto","Unusual line terminators are automatically removed."),nls.localize("unusualLineTerminators.off","Unusual line terminators are ignored."),nls.localize("unusualLineTerminators.prompt","Unusual line terminators prompt to be removed.")],description:nls.localize("unusualLineTerminators","Remove unusual line terminators that might cause problems.")})),useShadowDOM:register(new EditorBooleanOption(117,"useShadowDOM",!0)),useTabStops:register(new EditorBooleanOption(118,"useTabStops",!0,{description:nls.localize("useTabStops","Inserting and deleting whitespace follows tab stops.")})),wordSeparators:register(new EditorStringOption(119,"wordSeparators",USUAL_WORD_SEPARATORS,{description:nls.localize("wordSeparators","Characters that will be used as word separators when doing word related navigations or operations.")})),wordWrap:register(new EditorStringEnumOption(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[nls.localize("wordWrap.off","Lines will never wrap."),nls.localize("wordWrap.on","Lines will wrap at the viewport width."),nls.localize({key:"wordWrap.wordWrapColumn",comment:["- `editor.wordWrapColumn` refers to a different setting and should not be localized."]},"Lines will wrap at `#editor.wordWrapColumn#`."),nls.localize({key:"wordWrap.bounded",comment:["- viewport means the edge of the visible window size.","- `editor.wordWrapColumn` refers to a different setting and should not be localized."]},"Lines will wrap at the minimum of viewport and `#editor.wordWrapColumn#`.")],description:nls.localize({key:"wordWrap",comment:["- 'off', 'on', 'wordWrapColumn' and 'bounded' refer to values the setting can take and should not be localized.","- `editor.wordWrapColumn` refers to a different setting and should not be localized."]},"Controls how lines should wrap.")})),wordWrapBreakAfterCharacters:register(new EditorStringOption(121,"wordWrapBreakAfterCharacters"," \t})]?|/&.,;¢°′″‰℃、。｡､￠，．：；？！％・･ゝゞヽヾーァィゥェォッャュョヮヵヶぁぃぅぇぉっゃゅょゎゕゖㇰㇱㇲㇳㇴㇵㇶㇷㇸㇹㇺㇻㇼㇽㇾㇿ々〻ｧｨｩｪｫｬｭｮｯｰ”〉》」』】〕）］｝｣")),wordWrapBreakBeforeCharacters:register(new EditorStringOption(122,"wordWrapBreakBeforeCharacters","([{‘“〈《「『【〔（［｛｢£¥＄￡￥+＋")),wordWrapColumn:register(new EditorIntOption(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:nls.localize({key:"wordWrapColumn",comment:["- `editor.wordWrap` refers to a different setting and should not be localized.","- 'wordWrapColumn' and 'bounded' refer to values the different setting can take and should not be localized."]},"Controls the wrapping column of the editor when `#editor.wordWrap#` is `wordWrapColumn` or `bounded`.")})),wordWrapOverride1:register(new EditorStringEnumOption(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:register(new EditorStringEnumOption(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:register(new EditorEnumOption(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],_wrappingIndentFromString,{enumDescriptions:[nls.localize("wrappingIndent.none","No indentation. Wrapped lines begin at column 1."),nls.localize("wrappingIndent.same","Wrapped lines get the same indentation as the parent."),nls.localize("wrappingIndent.indent","Wrapped lines get +1 indentation toward the parent."),nls.localize("wrappingIndent.deepIndent","Wrapped lines get +2 indentation toward the parent.")],description:nls.localize("wrappingIndent","Controls the indentation of wrapped lines.")})),wrappingStrategy:register(new EditorStringEnumOption(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[nls.localize("wrappingStrategy.simple","Assumes that all characters are of the same width. This is a fast algorithm that works correctly for monospace fonts and certain scripts (like Latin characters) where glyphs are of equal width."),nls.localize("wrappingStrategy.advanced","Delegates wrapping points computation to the browser. This is a slow algorithm, that might cause freezes for large files, but it works correctly in all cases.")],description:nls.localize("wrappingStrategy","Controls the algorithm that computes wrapping points.")})),editorClassName:register(new EditorClassName),pixelRatio:register(new EditorPixelRatio),tabFocusMode:register(new EditorTabFocusMode),layoutInfo:register(new EditorLayoutInfoComputer),wrappingInfo:register(new EditorWrappingInfoComputer)};